DEFINT A-Z
DECLARE SUB EditEntryBG (EntryNum, TileNum)
DECLARE SUB EditEntryFG (EntryNum, TileNum)
DECLARE SUB EditAnimList (TileNum, Value)
DECLARE SUB EditAnimTime (Value)
DECLARE SUB TopFlagInfo ()
DECLARE SUB BottomFlagInfo ()
DECLARE SUB SideFlagInfo ()
DECLARE SUB MiscFlagInfo ()
CLS
PRINT ">>> CK456TLI <<<"
PRINT "A Commander Keen 4 - 6 TileInfo equivilent"
PRINT "Data collected by adurdin"
PRINT "Program written by The CK Guy"
PRINT
PRINT "This is public release one."
PRINT
PRINT "Make sure you read README.TXT before you use the program!"
PRINT
File$ = COMMAND$
IF File$ = "" THEN
   PRINT "You didn't enter a file name!"
   PRINT "For help, type CK456TLI /?"
   END
END IF
IF File$ = "/?" THEN
   PRINT "Usage:"
   PRINT
   PRINT "CK456TLI <filename>"
   PRINT
   PRINT "where <filename> is a file containing a Commander Keen Tiledat structure"
   PRINT
   PRINT "More info:"
   PRINT
   PRINT "To extract a copy of the Tiledat structure, use a filename that doesn't exist."
   PRINT "The data will be extracted into this file. In order to do this, however, you"
   PRINT "have Keens 4-6 version 1.4 in this directory, as well as CKxPATCH 0.9.0  in"
   PRINT "this directory or somewhere in your PATH."
   PRINT
   PRINT "Type CK456TLI /?? for more detailed help."
   END
END IF
IF File$ = "/??" THEN
   PRINT "CK456TLI is a TileInfo-like program (with lousy interface) for Commander Keen"
   PRINT "in 'Goodbye Galaxy!' and 'Aliens Ate My Babysitter!'  Once you've got a"
   PRINT "copy of the Tiledat structure loaded, you can begin to edit."
   PRINT
   PRINT "Detailed help unfinished."
   PRINT
   PRINT "I think the program is pretty self-explanitory.  You guys should be able to"
   PRINT "figure out how to use it."
   END
END IF
IF LEFT$(File$, 1) = "/" THEN F = 1: File$ = MID$(File$, 2)
File2$ = LEFT$(File$, 1) + LCASE$(MID$(File$, 2))
LoadTLI:
OPEN File$ FOR BINARY AS 1
SELECT CASE LOF(1)
   CASE 0
      IF F THEN
         PRINT File2$; " was not created successfully."
         PRINT "Make sure you have the keen executable and CKxPATCH in this directory."
         CLOSE 1
         KILL File$
         PRINT
         END
      END IF
      CLOSE 1
      KILL File$
GetEpisodeToCreateTLI:
      PRINT File2$; " was not found. This program will now help create it."
      LINE INPUT "What episode do you want the file to be for? "; Episode$
      OPEN "CK456TLI.TMP" FOR OUTPUT AS 1
      PRINT #1, "%EXT CK"; Episode$
      SELECT CASE Episode$
         CASE "4": PRINT #1, "%DUMP "; File$; " 0x249C2 23004"
         CASE "5": PRINT #1, "%DUMP "; File$; " 0x25B22 23688"
         CASE "6": PRINT #1, "%DUMP "; File$; " 0x25212 23904"
         CASE ELSE
            CLOSE 1
            PRINT "Bad episode number!"
            GOTO GetEpisodeToCreateTLI
      END SELECT
      PRINT #1, "%ABORT"
      PRINT #1, "%END"
      CLOSE 1
      OPEN "TILEDUMP.BAT" FOR OUTPUT AS 1
      PRINT #1, "@ECHO OFF"
      PRINT #1, "ECHO Calling CK"; Episode$; "PATCH.EXE to create "; File2$; " ..."
      PRINT #1, "ECHO."
      PRINT #1, "CK" + Episode$ + "PATCH CK456TLI.TMP"
      PRINT #1, "CK456TLI /" + File$
      PRINT #1, "DEL CK456TLI.TMP"
      PRINT #1, "ECHO."
      PRINT #1, "ECHO       -----------------"
      PRINT #1, "ECHO."
      PRINT #1, "ECHO You may now delete tiledump.bat"
      PRINT #1, "ECHO."
      CLOSE 1
      PRINT "Run tiledump.bat to create "; File2$; " ..."
      END
   CASE 23004
      Episode$ = "4"
      NumBg = 1296
      NumFG = 2916
      Where$ = "249c2"
   CASE 23688
      Episode$ = "5"
      NumBg = 1512
      NumFG = 2952
      Where$ = "25b22"
   CASE 23904
      Episode$ = "6"
      NumBg = 2376
      NumFG = 2736
      Where$ = "25212"
   CASE ELSE
      IF F THEN
         PRINT "Something went really wrong in the tile info extraction!"
      ELSE
         PRINT "Not a Tiledat resource dump! Use this program to create one."
      END IF
      CLOSE 1
      END
END SELECT
IF F THEN
   PRINT File2$; " was created successfully."
ELSE
   PRINT "By file length, "; File2$; " is for Keen "; Episode$; "."
END IF
PRINT
DIM SHARED BGdata(1, NumBg - 1), FGdata(6, NumFG - 1)
T$ = " "
PRINT "Loading background information ..."
   FOR I = 0 TO 1
      FOR J = 0 TO NumBg - 1
         GET 1, , T$
         BGdata(I, J) = ASC(T$)
   NEXT J, I
PRINT "Loading foreground information ..."
   FOR I = 0 TO 6
      FOR J = 0 TO NumFG - 1
         GET 1, , T$
         FGdata(I, J) = ASC(T$)
   NEXT J, I
CLOSE 1
Main:
CLS
PRINT "What do you want to edit?"
PRINT "(B)ackground tiles properties"
PRINT "(F)oreground tiles properties"
PRINT
PRINT "Or do you want to ..."
PRINT "(S)ave to disk"
PRINT "(Q)uit program"
GetOption:
T1$ = UCASE$(INPUT$(1))
SELECT CASE T1$
   CASE "B"
      Tile = 0
GetBGtile:
      CLS
      PRINT "Background tile number (Enter to go back";
      IF Tile <> 0 THEN PRINT ", last was 0x"; HEX$(Tile);
      PRINT "): 0x";
      LINE INPUT TileHex$
      IF TileHex$ = "" THEN GOTO Main
      Tile = VAL("&H" + TileHex$)
GetBGmode:
      CLS
      PRINT "What do you want to edit for background tile 0x"; HEX$(Tile); "?"
      PRINT "(N)ext tile in animation list"
      PRINT "(A)nimation timing"
      PRINT
      PRINT "Enter to go back"
GetBGmodeKey:
      EditMode$ = UCASE$(INPUT$(1))
      SELECT CASE EditMode$
         CASE "N": EditEntryBG 1, Tile
         CASE "A": EditEntryBG 0, Tile
         CASE CHR$(13): GOTO GetBGtile
         CASE ELSE: GOTO GetBGmodeKey
      END SELECT
      GOTO GetBGmode
   CASE "F"
      Tile = 0
GetFGtile:
      CLS
      PRINT "Foreground tile number (Enter to go back";
      IF Tile <> 0 THEN PRINT ", last was 0x"; HEX$(Tile);
      IF Tile > NumFG THEN PRINT ", max is 0x"; HEX$(NumFG);
      PRINT "): 0x";
      LINE INPUT TileHex$
      IF TileHex$ = "" THEN GOTO Main
      Tile = VAL("&H" + TileHex$)
      IF Tile > NumFG THEN GOTO GetFGtile
GetFGmode:
      CLS
      PRINT "What do you want to edit for foreground tile 0x"; HEX$(Tile); "?"
      PRINT "(T)op flag"
      PRINT "(B)ottom flag"
      PRINT "(L)eft flag"
      PRINT "(R)ight flag"
      PRINT "(M)isc flag"
      PRINT "(N)ext tile in animation list"
      PRINT "(A)nimation timing"
      PRINT
      PRINT "Enter to go back"
GetFGmodeKey:
      EditMode$ = UCASE$(INPUT$(1))
      SELECT CASE EditMode$
         CASE "T": EditEntryFG 0, Tile
         CASE "B": EditEntryFG 2, Tile
         CASE "L": EditEntryFG 3, Tile
         CASE "R": EditEntryFG 1, Tile
         CASE "M": EditEntryFG 5, Tile
         CASE "N": EditEntryFG 4, Tile
         CASE "A": EditEntryFG 6, Tile
         CASE CHR$(13): GOTO GetFGtile
         CASE ELSE: GOTO GetFGmodeKey
      END SELECT
      GOTO GetFGmode
   CASE "S"
      INPUT "Save as ... (enter for same file) ", File3$
      IF File3$ <> "" THEN
         File$ = UCASE$(File3$)
         File2$ = LEFT$(File$, 1) + MID$(LCASE$(File$), 2)
      END IF
      OPEN File$ FOR BINARY AS 1: CLOSE 1
      KILL File$
      OPEN File$ FOR BINARY AS 1
      PRINT "Saving background information ..."
         FOR I = 0 TO 1
         FOR J = 0 TO NumBg - 1
         T$ = CHR$(BGdata(I, J))
         PUT 1, , T$
         NEXT J, I
      PRINT "Saving foreground information ..."
         FOR I = 0 TO 6
         FOR J = 0 TO NumFG - 1
         T$ = CHR$(FGdata(I, J))
         PUT 1, , T$
         NEXT J, I
      CLOSE 1
   CASE "Q"
      CLS
      PRINT "Use a patch file something like this:"
      PRINT
      PRINT "%ext ck"; Episode$
      PRINT
      PRINT "# Only use Keen "; Episode$; " v1.4 ..."
      PRINT "%version 1.4"
      PRINT
      PRINT "# Replace Tiledat structure - loads new tile properties ..."
      PRINT "%patchfile 0x"; Where$; " "; LCASE$(File$)
      PRINT
      PRINT "%end"
      PRINT
      PRINT "Don't forget to visit Keen: Modding and tell me what you think!"
      END
END SELECT
GOTO Main:

SUB BottomFlagInfo
PRINT "0x00 - Jump through"
PRINT "0x01 - Flat bottom"
PRINT "0x02 - Lower  left  to  middle right"
PRINT "0x03 - Middle left  to  upper  right"
PRINT "0x04 - Lower  left  to  upper  right"
PRINT "0x05 - Middle left  to  lower  right"
PRINT "0x06 - Upper  left  to  middle right"
PRINT "0x07 - Upper  left  to  lower  right"
PRINT "0x11 - Pole going through."
PRINT "0x21 - (Keen 6) Used for giant switch."
END SUB

SUB EditAnimList (TileNum, Value)
IF Value > 128 THEN Offset = Value - 256 ELSE Offset = Value
PRINT "Next tile is 0x"; HEX$(TileNum + Offset)
GetOffset:
LINE INPUT "New next tile is 0x"; T$
IF T$ = "" THEN EXIT SUB
Offset = VAL("&H" + T$) - TileNum
IF Offset > -128 AND Offset < 0 THEN
   Value = Offset + 256
ELSEIF Offset > -1 AND Offset < 128 THEN
   Value = Offset
ELSE
   PRINT "Too far from original tile, can from 0x"; HEX$(TileNum - 127); " to 0x"; HEX$(TileNum + 127); "."
   GOTO GetOffset
END IF
END SUB

SUB EditAnimTime (Value)
PRINT "Time on tile is"; INT(Value / 149 * 2 * 100 + .5) / 100; "seconds."
GetTime:
INPUT "New time is ", T$
IF T$ = "" THEN EXIT SUB
Value = INT(VAL(T$) / 2 * 149 + .5)
IF Value > 255 THEN PRINT "Too long.": GOTO GetTime
BGdata(0, TileNum) = Value
END SUB

SUB EditEntryBG (EntryNum, TileNum)
CLS
PRINT "Editing ";
SELECT CASE EntryNum
   CASE 0: PRINT "animation timing";
   CASE 1: PRINT "next tile in animation list";
END SELECT
PRINT " for tile 0x"; HEX$(TileNum)
SELECT CASE EntryNum
   CASE 0: EditAnimTime BGdata(0, TileNum)
   CASE 1: EditAnimList TileNum, BGdata(1, TileNum)
END SELECT
END SUB

SUB EditEntryFG (EntryNum, TileNum)
CLS
PRINT "Editing ";
SELECT CASE EntryNum
   CASE 0: PRINT "top flag";
   CASE 1: PRINT "right flag";
   CASE 2: PRINT "bottom flag";
   CASE 3: PRINT "left flag";
   CASE 4: PRINT "next in animation list";
   CASE 5: PRINT "misc flag";
   CASE 6: PRINT "animation timing";
END SELECT
PRINT " for tile 0x"; HEX$(TileNum)
SELECT CASE EntryNum
   CASE 0: TopFlagInfo
   CASE 1: SideFlagInfo
   CASE 2: BottomFlagInfo
   CASE 3: SideFlagInfo
   CASE 4: EditAnimList TileNum, FGdata(4, TileNum): EXIT SUB
   CASE 5: MiscFlagInfo
   CASE 6: EditAnimTime FGdata(6, TileNum): EXIT SUB
END SELECT
PRINT "Currently 0x"; HEX$(FGdata(EntryNum, TileNum)); ", new value 0x";
LINE INPUT ValueHex$
IF ValueHex$ <> "" THEN FGdata(EntryNum, TileNum) = VAL("&H" + ValueHex$)
END SUB

SUB MiscFlagInfo
PRINT "0x00 - No special properties"
PRINT "0x01 - Pole"
PRINT "0x02 - Door, also entry to Miragia"
PRINT "0x03 - Deadly"
PRINT "0x04 - Lifewater drop"
PRINT "0x05 - Off switch",
PRINT "0x06 - On switch"
PRINT "0x07 - Red keygem holder",
PRINT "0x08 - Yellow keygem holder",
PRINT "0x09 - Blue keygem holder",
PRINT "0x0A - Green keygem holder"
PRINT "0x0F - Throw switch"
PRINT "0x12 - (Keen 5, 6) Toggled platform"
PRINT "0x13 - (Keen 6) ?? Used for top of active zapper"
PRINT "0x14 - (Keen 5, 6) (?? blank tile - 5) Teleporter entrance"
PRINT "0x15 - 100 point item",
PRINT "0x16 - 200 point item",
PRINT "0x17 - 500 point item",
PRINT "0x18 - 1000 point item",
PRINT "0x19 - 2000 point item",
PRINT "0x1A - 5000 point item",
PRINT "0x1B - Extra Life",
PRINT "0x1C - 5 shots"
PRINT "0x1E - (Keen 6) ?? Used for top + bottom of inactive zapper"
PRINT "0x1F - (Keen 5) Little Ampton's computer"
PRINT "0x21 - (Keen 5) Left-hand side of elevator entrance on map"
PRINT "0x22 - (Keen 5) Right-hand side of elevator entrance on map"
PRINT "0x80 - Add to misc flag value to make the tile go in front of Keen"
END SUB

SUB SideFlagInfo
PRINT "0x00 - Walk through"
PRINT "0x01 - Solid (need not apply to sloped bricks)"
END SUB

SUB TopFlagInfo
PRINT "0x00 - Fall through"
PRINT "0x01 - Flat top (can stand on, grab on)"
PRINT "0x02 - Upper  left  to  middle right"
PRINT "0x03 - Middle left  to  lower  right"
PRINT "0x04 - Upper  left  to  lower  right"
PRINT "0x05 - Middle left  to  upper  right"
PRINT "0x06 - Lower  left  to  middle right"
PRINT "0x07 - Lower  left  to  upper  right"
PRINT "0x09 - Solid, but cannot land on in God mode; kills."
PRINT "0x11 - Flat top, with pole going through."
PRINT "0x1D - (Keen 6) ?? Used for one tile of conv. belt - jerks Keen right"
PRINT "0x21 - (Keen 6) Used for giant switch."
PRINT "0x29 - (Keen 6) Conveyor belt."
PRINT "0x39 - (Keen 5) Fuse; solid, but pogo breaks it."
PRINT "0xFF - (Keen 4) ?? (fg tile 16*18+7)"
END SUB

